package mods.immibis.tubestuff;

import static net.minecraftforge.client.IItemRenderer.ItemRenderType.*;
import static org.lwjgl.opengl.GL11.*;
import mods.immibis.core.api.util.Dir;
import net.minecraft.block.Block;
import net.minecraft.client.Minecraft;
import net.minecraft.client.renderer.OpenGlHelper;
import net.minecraft.client.renderer.RenderBlocks;
import net.minecraft.client.renderer.Tessellator;
import net.minecraft.client.renderer.tileentity.TileEntitySpecialRenderer;
import net.minecraft.item.Item;
import net.minecraft.item.ItemBlock;
import net.minecraft.item.ItemStack;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.Icon;
import net.minecraft.util.MathHelper;
import net.minecraftforge.client.ForgeHooksClient;
import net.minecraftforge.client.IItemRenderer;
import net.minecraftforge.client.MinecraftForgeClient;

import org.lwjgl.opengl.GL11;
import org.lwjgl.opengl.GL12;

import cpw.mods.fml.relauncher.Side;
import cpw.mods.fml.relauncher.SideOnly;

// render pickaxe coming out the front, swinging when it breaks a block
@SideOnly(Side.CLIENT)
public class RenderTileBlockBreaker extends TileEntitySpecialRenderer {
	private RenderBlocks renderBlocks = new RenderBlocks();
	
	private static final boolean TOOL_STICKS_OUT = false;
	private static final boolean RENDER_PISTON = false;
	static final boolean HALF_HEIGHT = false;

	@Override
	public void renderTileEntityAt(TileEntity var1, double x, double y, double z, float partialTick) {
		TileBlockBreaker te = (TileBlockBreaker)var1;
		ItemStack tool = te.getTool();
		
		float swingTime = te.swingTime + (te.isBreaking || te.swingTime != 0 ? partialTick : 0);
		float angle = (float)(1 - Math.cos(swingTime / TileBlockBreaker.SWING_PERIOD * 2 * Math.PI)) * -45;
		
		//OpenGlHelper.setActiveTexture(OpenGlHelper.lightmapTexUnit);
		//GL11.glDisable(GL11.GL_TEXTURE_2D);
		//OpenGlHelper.setActiveTexture(OpenGlHelper.defaultTexUnit);
		
		int br = te.worldObj.getLightBrightnessForSkyBlocks(te.xCoord, te.yCoord, te.zCoord, 0);
		OpenGlHelper.setLightmapTextureCoords(OpenGlHelper.lightmapTexUnit, br & 0xFFFF, br >> 16);
		
		glPushMatrix();
		glTranslated(x+0.5, y+8/16.0, z+0.5);
		
		glDisable(GL_LIGHTING);
		
		switch(te.facing) {
		case Dir.PX: break;
		case Dir.NX: glRotatef(180, 0, 1, 0); break;
		case Dir.PZ: glRotatef(-90, 0, 1, 0); break;
		case Dir.NZ: glRotatef(90, 0, 1, 0); break;
		}
		
		// Render piston
		if(RENDER_PISTON)
		{
			double pistonExtensionDist = angle / -90;
			
			GL11.glBindTexture(GL11.GL_TEXTURE_2D, tileEntityRenderer.renderEngine.getTexture("/terrain.png"));
			Tessellator t = Tessellator.instance;
			double u, v, du, dv;
			
			double _x = -0.5;
			double _y = -0.5;
			double _z = -0.25;
			double cx = 0.5, cy=0.5*0.75, cz=0.5;
			
			t.startDrawingQuads();
			t.setBrightness(te.worldObj.getLightBrightnessForSkyBlocks(te.xCoord, te.yCoord, te.zCoord, 0));
			
			// base
			
			u = 208/256.0; v = 96/256.0; du = dv = 1/16.0;
			
			t.setNormal(0.0F, -1.0F, 0.0F);
	        t.addVertexWithUV(_x   , _y, _z   , u, v);
			t.addVertexWithUV(_x+cx, _y, _z   , u+du, v);
			t.addVertexWithUV(_x+cx, _y, _z+cz, u+du, v+dv);
			t.addVertexWithUV(_x   , _y, _z+cz, u, v+dv);
			
			u = 192/256.0; v = 100/256.0; dv = 12/256.0; 
			
			t.setNormal(0.0F, 0.0F, -1.0F);
	        t.addVertexWithUV(_x+cx, _y+cy, _z, u, v);
			t.addVertexWithUV(_x+cx, _y   , _z, u, v+dv);
			t.addVertexWithUV(_x   , _y   , _z, u+du, v+dv);
			t.addVertexWithUV(_x   , _y+cy, _z, u+du, v);
			
			t.setNormal(0.0F, 0.0F, 1.0F);
	        t.addVertexWithUV(_x+cx, _y+cy, _z+cz, u, v);
			t.addVertexWithUV(_x   , _y+cy, _z+cz, u+du, v);
			t.addVertexWithUV(_x   , _y   , _z+cz, u+du, v+dv);
			t.addVertexWithUV(_x+cx, _y   , _z+cz, u, v+dv);
			
			t.setNormal(-1.0F, 0.0F, 0.0F);
	        t.addVertexWithUV(_x, _y+cy, _z   , u, v);
			t.addVertexWithUV(_x, _y   , _z   , u, v+dv);
			t.addVertexWithUV(_x, _y   , _z+cz, u+du, v+dv);
			t.addVertexWithUV(_x, _y+cy, _z+cz, u+du, v);
			
			t.setNormal(1.0F, 0.0F, 0.0F);
	        t.addVertexWithUV(_x+cx, _y+cy, _z   , u, v);
			t.addVertexWithUV(_x+cx, _y+cy, _z+cz, u+du, v);
			t.addVertexWithUV(_x+cx, _y   , _z+cz, u+du, v+dv);
			t.addVertexWithUV(_x+cx, _y   , _z   , u, v+dv);
			
			u = 224/256.0; v = 96/256.0; dv = 1/16.0;
			
			t.setNormal(0.0F, 1.0F, 0.0F);
	        t.addVertexWithUV(_x   , _y+cy, _z   , u, v);
			t.addVertexWithUV(_x   , _y+cy, _z+cz, u, v+dv);
			t.addVertexWithUV(_x+cx, _y+cy, _z+cz, u+du, v+dv);
			t.addVertexWithUV(_x+cx, _y+cy, _z   , u+du, v);
			
			double baseTop = y + cy;
			
			// head
			cy /= 3;
			//_y = (1 - 4*cy) * pistonExtensionDist - 0.5 + 3*cy;
			_y = Math.sin(-angle*Math.PI/180)*6/16 - cy;
			double headBottom = _y;
			
			u = 176/256.0; v = 96/256.0; du = dv = 1/16.0;
			
			t.setNormal(0.0F, -1.0F, 0.0F);
	        t.addVertexWithUV(_x   , _y, _z   , u, v);
			t.addVertexWithUV(_x+cx, _y, _z   , u+du, v);
			t.addVertexWithUV(_x+cx, _y, _z+cz, u+du, v+dv);
			t.addVertexWithUV(_x   , _y, _z+cz, u, v+dv);
			
			u = 192/256.0; v = 96/256.0; dv = 4/256.0; 
			
			t.setNormal(0.0F, 0.0F, -1.0F);
	        t.addVertexWithUV(_x+cx, _y+cy, _z, u, v);
			t.addVertexWithUV(_x+cx, _y   , _z, u, v+dv);
			t.addVertexWithUV(_x   , _y   , _z, u+du, v+dv);
			t.addVertexWithUV(_x   , _y+cy, _z, u+du, v);
			
			t.setNormal(0.0F, 0.0F, 1.0F);
	        t.addVertexWithUV(_x+cx, _y+cy, _z+cz, u, v);
			t.addVertexWithUV(_x   , _y+cy, _z+cz, u+du, v);
			t.addVertexWithUV(_x   , _y   , _z+cz, u+du, v+dv);
			t.addVertexWithUV(_x+cx, _y   , _z+cz, u, v+dv);
			
			t.setNormal(-1.0F, 0.0F, 0.0F);
	        t.addVertexWithUV(_x, _y+cy, _z   , u, v);
			t.addVertexWithUV(_x, _y   , _z   , u, v+dv);
			t.addVertexWithUV(_x, _y   , _z+cz, u+du, v+dv);
			t.addVertexWithUV(_x, _y+cy, _z+cz, u+du, v);
			
			t.setNormal(1.0F, 0.0F, 0.0F);
	        t.addVertexWithUV(_x+cx, _y+cy, _z   , u, v);
			t.addVertexWithUV(_x+cx, _y+cy, _z+cz, u+du, v);
			t.addVertexWithUV(_x+cx, _y   , _z+cz, u+du, v+dv);
			t.addVertexWithUV(_x+cx, _y   , _z   , u, v+dv);
			
			u = 176/256.0; v = 96/256.0; dv = 1/16.0;
			
			t.setNormal(0.0F, 1.0F, 0.0F);
	        t.addVertexWithUV(_x   , _y+cy, _z   , u, v);
			t.addVertexWithUV(_x   , _y+cy, _z+cz, u, v+dv);
			t.addVertexWithUV(_x+cx, _y+cy, _z+cz, u+du, v+dv);
			t.addVertexWithUV(_x+cx, _y+cy, _z   , u+du, v);
			
			// arm
			cx /= 4;
			cz /= 4;
			cy *= 4;
			_x += cx*1.5;
			_z += cz*1.5;
			_y = headBottom - cy;
			
			//u = 208/256.0; v = 96/256.0; du = dv = 1/16.0;
			
			//t.setNormal(0.0F, -1.0F, 0.0F);
	        //t.addVertexWithUV(_x   , _y, _z   , u, v);
			//t.addVertexWithUV(_x+cx, _y, _z   , u+du, v);
			//t.addVertexWithUV(_x+cx, _y, _z+cz, u+du, v+dv);
			//t.addVertexWithUV(_x   , _y, _z+cz, u, v+dv);
			
			u = 192/256.0; v = 96/256.0; dv = 4/256.0; 
			
			t.setNormal(0.0F, 0.0F, -1.0F);
	        t.addVertexWithUV(_x+cx, _y+cy, _z, u, v);
			t.addVertexWithUV(_x+cx, _y   , _z, u+du, v);
			t.addVertexWithUV(_x   , _y   , _z, u+du, v+dv);
			t.addVertexWithUV(_x   , _y+cy, _z, u, v+dv);
			
			t.setNormal(0.0F, 0.0F, 1.0F);
	        t.addVertexWithUV(_x+cx, _y+cy, _z+cz, u, v);
			t.addVertexWithUV(_x   , _y+cy, _z+cz, u, v+dv);
			t.addVertexWithUV(_x   , _y   , _z+cz, u+du, v+dv);
			t.addVertexWithUV(_x+cx, _y   , _z+cz, u+du, v);
			
			t.setNormal(-1.0F, 0.0F, 0.0F);
	        t.addVertexWithUV(_x, _y+cy, _z   , u, v);
			t.addVertexWithUV(_x, _y   , _z   , u+du, v);
			t.addVertexWithUV(_x, _y   , _z+cz, u+du, v+dv);
			t.addVertexWithUV(_x, _y+cy, _z+cz, u, v+dv);
			
			t.setNormal(1.0F, 0.0F, 0.0F);
	        t.addVertexWithUV(_x+cx, _y+cy, _z   , u, v);
			t.addVertexWithUV(_x+cx, _y+cy, _z+cz, u, v+dv);
			t.addVertexWithUV(_x+cx, _y   , _z+cz, u+du, v+dv);
			t.addVertexWithUV(_x+cx, _y   , _z   , u+du, v);
			
			//u = 224/256.0; v = 96/256.0; dv = 1/16.0;
			
			//t.setNormal(0.0F, 1.0F, 0.0F);
	        //t.addVertexWithUV(_x   , _y+cy, _z   , u, v);
			//t.addVertexWithUV(_x   , _y+cy, _z+cz, u, v+dv);
			//t.addVertexWithUV(_x+cx, _y+cy, _z+cz, u+du, v+dv);
			//t.addVertexWithUV(_x+cx, _y+cy, _z   , u+du, v);
			
			t.draw();
		}
		
		
		glRotatef(angle, 0, 0, 1);
		
		glColor3f(1, 1, 1);
		
		// Render tool
		if(tool != null)
		{
			GL11.glPushMatrix();
			float f4 = 0.8F;

            float f7 = 0; // swing progress
            float f6 = MathHelper.sin(f7 * (float)Math.PI);
            float f5 = MathHelper.sin(MathHelper.sqrt_float(f7) * (float)Math.PI);
            //GL11.glTranslatef(-f5 * 0.4F, MathHelper.sin(MathHelper.sqrt_float(f7) * (float)Math.PI * 2.0F) * 0.2F, -f6 * 0.2F);

            GL11.glTranslatef(0.5f, -0.5f, 0);
            GL11.glRotatef(180.0F, 0.0F, 1.00F, 0.0F);
            GL11.glEnable(GL12.GL_RESCALE_NORMAL);
            f7 = 0; // swing progress
            f6 = MathHelper.sin(f7 * f7 * (float)Math.PI);
            f5 = MathHelper.sin(MathHelper.sqrt_float(f7) * (float)Math.PI);
            //GL11.glRotatef(-f6 * 20.0F, 0.0F, 1.0F, 0.0F);
            //GL11.glRotatef(-f5 * 20.0F, 0.0F, 0.0F, 1.0F);
            //GL11.glRotatef(-f5 * 80.0F, 1.0F, 0.0F, 0.0F);
            float f8 = 0.4F;
            //GL11.glScalef(f8, f8, f8);
            float f11;
            float f12;

            
            if (tool.getItem().shouldRotateAroundWhenRendering())
            {
                GL11.glRotatef(180.0F, 0.0F, 1.0F, 0.0F);
            }

            if (tool.getItem().requiresMultipleRenderPasses())
            {
                this.renderItem(tool, 0);
                for (int k = 1; k < tool.getItem().getRenderPasses(tool.getItemDamage()); k++)
                {
                    int i1 = Item.itemsList[tool.itemID].getColorFromItemStack(tool, k);
                    float f10 = (float)(i1 >> 16 & 255) / 255.0F;
                    f11 = (float)(i1 >> 8 & 255) / 255.0F;
                    f12 = (float)(i1 & 255) / 255.0F;
                    GL11.glColor4f(f10, f11, f12, 1.0F);
                    this.renderItem(tool, k);
                }
            }
            else
            {
                this.renderItem(tool, 0);
            }

            GL11.glPopMatrix();
		}
		
		// Render axle
		{
			double th = 1/16.0;
			Tessellator t = Tessellator.instance;
			glDisable(GL_TEXTURE_2D);
			t.startDrawing(GL_QUAD_STRIP);
			t.setBrightness(te.worldObj.getLightBrightnessForSkyBlocks(te.xCoord, te.yCoord, te.zCoord, 0));
			t.setColorOpaque(0, 50, 50);
			t.addVertex(-th,  0,-0.5);
			t.addVertex(-th,  0, 0.5);
			t.addVertex(  0, th,-0.5);
			t.addVertex(  0, th, 0.5);
			t.addVertex( th,  0,-0.5);
			t.addVertex( th,  0, 0.5);
			t.addVertex(  0,-th,-0.5);
			t.addVertex(  0,-th, 0.5);
			t.addVertex(-th,  0,-0.5);
			t.addVertex(-th,  0, 0.5);
			t.draw();
			glEnable(GL_TEXTURE_2D);
		}
		
		// Render piston "handle"
		if(RENDER_PISTON)
		{
			Tessellator t = Tessellator.instance;
			GL11.glBindTexture(GL11.GL_TEXTURE_2D, tileEntityRenderer.renderEngine.getTexture("/immibis/tubestuff/blocks.png"));
			t.startDrawing(GL_QUADS);
			t.setBrightness(te.worldObj.getLightBrightnessForSkyBlocks(te.xCoord, te.yCoord, te.zCoord, 0));
			t.addVertexWithUV( 0  , 0.01, -0.5, 224/256.0, 8/256.0);
			t.addVertexWithUV( 0  , 0.01,  0.5, 240/256.0, 8/256.0);
			t.addVertexWithUV(-0.5, 0.01,  0.5, 240/256.0, 16/256.0);
			t.addVertexWithUV(-0.5, 0.01, -0.5, 224/256.0, 16/256.0);
			
			t.addVertexWithUV( 0  , 0.01, -0.5, 224/256.0, 8/256.0);
			t.addVertexWithUV(-0.5, 0.01, -0.5, 224/256.0, 16/256.0);
			t.addVertexWithUV(-0.5, 0.01,  0.5, 240/256.0, 16/256.0);
			t.addVertexWithUV( 0  , 0.01,  0.5, 240/256.0, 8/256.0);
			t.draw();
		}
        
		glPopMatrix();
		
		glEnable(GL_LIGHTING);
		
		OpenGlHelper.setActiveTexture(OpenGlHelper.lightmapTexUnit);
		GL11.glEnable(GL11.GL_TEXTURE_2D);
		OpenGlHelper.setActiveTexture(OpenGlHelper.defaultTexUnit);
	}
	
	public void renderItem(ItemStack par2ItemStack, int par3)
    {
        GL11.glPushMatrix();
        
        Block block = null;
        if (par2ItemStack.getItem() instanceof ItemBlock && par2ItemStack.itemID < Block.blocksList.length)
        {
            block = Block.blocksList[par2ItemStack.itemID];
        }

        IItemRenderer customRenderer = MinecraftForgeClient.getItemRenderer(par2ItemStack, EQUIPPED);
        
        if (customRenderer != null)
        {
            this.tileEntityRenderer.renderEngine.bindTexture(par2ItemStack.getItemSpriteNumber() == 0 ? "/terrain.png" : "/gui/items.png");
            ForgeHooksClient.renderEquippedItem(customRenderer, renderBlocks, null, par2ItemStack);
        }
        else if (block != null && par2ItemStack.getItemSpriteNumber() == 0 && RenderBlocks.renderItemIn3d(Block.blocksList[par2ItemStack.itemID].getRenderType()))
        {
            this.tileEntityRenderer.renderEngine.bindTexture("/terrain.png");
            GL11.glTranslatef(0.5f, 0.5f, 0);
            float s = (float)(1/Math.sqrt(2));
            GL11.glScalef(s, s, s);
            this.renderBlocks.renderBlockAsItem(Block.blocksList[par2ItemStack.itemID], par2ItemStack.getItemDamage(), 1.0F);
        }
        else
        {
            Icon icon = par2ItemStack.getIconIndex();

            if (icon == null)
            {
                return;
            }

            if (par2ItemStack.getItemSpriteNumber() == 0)
            {
                this.tileEntityRenderer.renderEngine.bindTexture("/terrain.png");
            }
            else
            {
                this.tileEntityRenderer.renderEngine.bindTexture("/gui/items.png");
            }

            Tessellator tessellator = Tessellator.instance;
            float f = icon.getMinV();
            float f1 = icon.getMinU();
            float f2 = icon.getMaxV();
            float f3 = icon.getMaxU();
            float f4 = 0.0F;
            float f5 = 0.3F;
            GL11.glEnable(GL12.GL_RESCALE_NORMAL);
            //GL11.glTranslatef(-f4, -f5, 0.0F);
            //float f6 = 1.5F;
            //GL11.glScalef(f6, f6, f6);
            //GL11.glRotatef(50.0F, 0.0F, 1.0F, 0.0F);
            //GL11.glRotatef(335.0F, 0.0F, 0.0F, 1.0F);
            //GL11.glTranslatef(-0.9375F, -0.0625F, 0.0F);
            renderItemIn2D(tessellator, f1, f2, f, f3, icon.getSheetWidth(), icon.getSheetHeight(), 0.0625F);

            if (par2ItemStack != null && par2ItemStack.hasEffect() && par3 == 0)
            {
                GL11.glDepthFunc(GL11.GL_EQUAL);
                GL11.glDisable(GL11.GL_LIGHTING);
                this.tileEntityRenderer.renderEngine.bindTexture("%blur%/misc/glint.png");
                GL11.glEnable(GL11.GL_BLEND);
                GL11.glBlendFunc(GL11.GL_SRC_COLOR, GL11.GL_ONE);
                float f7 = 0.76F;
                GL11.glColor4f(0.5F * f7, 0.25F * f7, 0.8F * f7, 1.0F);
                GL11.glMatrixMode(GL11.GL_TEXTURE);
                GL11.glPushMatrix();
                float f8 = 0.125F;
                GL11.glScalef(f8, f8, f8);
                float f9 = (float)(Minecraft.getSystemTime() % 3000L) / 3000.0F * 8.0F;
                GL11.glTranslatef(f9, 0.0F, 0.0F);
                GL11.glRotatef(-50.0F, 0.0F, 0.0F, 1.0F);
                renderItemIn2D(tessellator, 0.0F, 0.0F, 1.0F, 1.0F, 256, 256, 0.0625F);
                GL11.glPopMatrix();
                GL11.glPushMatrix();
                GL11.glScalef(f8, f8, f8);
                f9 = (float)(Minecraft.getSystemTime() % 4873L) / 4873.0F * 8.0F;
                GL11.glTranslatef(-f9, 0.0F, 0.0F);
                GL11.glRotatef(10.0F, 0.0F, 0.0F, 1.0F);
                renderItemIn2D(tessellator, 0.0F, 0.0F, 1.0F, 1.0F, 256, 256, 0.0625F);
                GL11.glPopMatrix();
                GL11.glMatrixMode(GL11.GL_MODELVIEW);
                GL11.glDisable(GL11.GL_BLEND);
                GL11.glEnable(GL11.GL_LIGHTING);
                GL11.glDepthFunc(GL11.GL_LEQUAL);
            }

            GL11.glDisable(GL12.GL_RESCALE_NORMAL);
        }

        GL11.glPopMatrix();
    }

    private void renderItemIn2D(Tessellator par0Tessellator, float par1, float par2, float par3, float par4, int par5, int par6, float par7)
    {
    	par0Tessellator.startDrawingQuads();
        par0Tessellator.setNormal(0.0F, 0.0F, 1.0F);
        par0Tessellator.addVertexWithUV(0.0D, 0.0D, 0.0D, (double)par1, (double)par4);
        par0Tessellator.addVertexWithUV(1.0D, 0.0D, 0.0D, (double)par3, (double)par4);
        par0Tessellator.addVertexWithUV(1.0D, 1.0D, 0.0D, (double)par3, (double)par2);
        par0Tessellator.addVertexWithUV(0.0D, 1.0D, 0.0D, (double)par1, (double)par2);
        par0Tessellator.draw();
        par0Tessellator.startDrawingQuads();
        par0Tessellator.setNormal(0.0F, 0.0F, -1.0F);
        par0Tessellator.addVertexWithUV(0.0D, 1.0D, (double)(0.0F - par7), (double)par1, (double)par2);
        par0Tessellator.addVertexWithUV(1.0D, 1.0D, (double)(0.0F - par7), (double)par3, (double)par2);
        par0Tessellator.addVertexWithUV(1.0D, 0.0D, (double)(0.0F - par7), (double)par3, (double)par4);
        par0Tessellator.addVertexWithUV(0.0D, 0.0D, (double)(0.0F - par7), (double)par1, (double)par4);
        par0Tessellator.draw();
        float f5 = (float)par5 * (par1 - par3);
        float f6 = (float)par6 * (par4 - par2);
        par0Tessellator.startDrawingQuads();
        par0Tessellator.setNormal(-1.0F, 0.0F, 0.0F);
        int k;
        float f7;
        float f8;

        for (k = 0; (float)k < f5; ++k)
        {
            f7 = (float)k / f5;
            f8 = par1 + (par3 - par1) * f7 - 0.5F / (float)par5;
            par0Tessellator.addVertexWithUV((double)f7, 0.0D, (double)(0.0F - par7), (double)f8, (double)par4);
            par0Tessellator.addVertexWithUV((double)f7, 0.0D, 0.0D, (double)f8, (double)par4);
            par0Tessellator.addVertexWithUV((double)f7, 1.0D, 0.0D, (double)f8, (double)par2);
            par0Tessellator.addVertexWithUV((double)f7, 1.0D, (double)(0.0F - par7), (double)f8, (double)par2);
        }

        par0Tessellator.draw();
        par0Tessellator.startDrawingQuads();
        par0Tessellator.setNormal(1.0F, 0.0F, 0.0F);
        float f9;

        for (k = 0; (float)k < f5; ++k)
        {
            f7 = (float)k / f5;
            f8 = par1 + (par3 - par1) * f7 - 0.5F / (float)par5;
            f9 = f7 + 1.0F / f5;
            par0Tessellator.addVertexWithUV((double)f9, 1.0D, (double)(0.0F - par7), (double)f8, (double)par2);
            par0Tessellator.addVertexWithUV((double)f9, 1.0D, 0.0D, (double)f8, (double)par2);
            par0Tessellator.addVertexWithUV((double)f9, 0.0D, 0.0D, (double)f8, (double)par4);
            par0Tessellator.addVertexWithUV((double)f9, 0.0D, (double)(0.0F - par7), (double)f8, (double)par4);
        }

        par0Tessellator.draw();
        par0Tessellator.startDrawingQuads();
        par0Tessellator.setNormal(0.0F, 1.0F, 0.0F);

        for (k = 0; (float)k < f6; ++k)
        {
            f7 = (float)k / f6;
            f8 = par4 + (par2 - par4) * f7 - 0.5F / (float)par6;
            f9 = f7 + 1.0F / f6;
            par0Tessellator.addVertexWithUV(0.0D, (double)f9, 0.0D, (double)par1, (double)f8);
            par0Tessellator.addVertexWithUV(1.0D, (double)f9, 0.0D, (double)par3, (double)f8);
            par0Tessellator.addVertexWithUV(1.0D, (double)f9, (double)(0.0F - par7), (double)par3, (double)f8);
            par0Tessellator.addVertexWithUV(0.0D, (double)f9, (double)(0.0F - par7), (double)par1, (double)f8);
        }

        par0Tessellator.draw();
        par0Tessellator.startDrawingQuads();
        par0Tessellator.setNormal(0.0F, -1.0F, 0.0F);

        for (k = 0; (float)k < f6; ++k)
        {
            f7 = (float)k / f6;
            f8 = par4 + (par2 - par4) * f7 - 0.5F / (float)par6;
            par0Tessellator.addVertexWithUV(1.0D, (double)f7, 0.0D, (double)par3, (double)f8);
            par0Tessellator.addVertexWithUV(0.0D, (double)f7, 0.0D, (double)par1, (double)f8);
            par0Tessellator.addVertexWithUV(0.0D, (double)f7, (double)(0.0F - par7), (double)par1, (double)f8);
            par0Tessellator.addVertexWithUV(1.0D, (double)f7, (double)(0.0F - par7), (double)par3, (double)f8);
        }

        par0Tessellator.draw();
    }
}